#!/bin/bash

if [ $# -ne 1 ];then
  echo "Please add the <directory> as parameter."
  exit 1
fi

directory_name="$1"

mkdir -p ../keep_recognition/"$directory_name"/voice_recognition
mkdir -p ../keep_recognition/"$directory_name"/face_recognition


##### voice recognition

cp "$directory_name"/voice_recognition/"$directory_name"/voices.txt ../keep_recognition/"$directory_name"/voice_recognition
cp "$directory_name"/voice_recognition/"$directory_name"/final.txt ../keep_recognition/"$directory_name"/voice_recognition
cp "$directory_name"/voice_recognition/"$directory_name"/voice_check.txt ../keep_recognition/"$directory_name"/voice_recognition
cp "$directory_name"/voice_recognition/"$directory_name"/best_matching_voice_combined_cutlist.txt ../keep_recognition/"$directory_name"/voice_recognition


##### face recognition

cp "$directory_name"/face_recognition/combined_recognition.html ../keep_recognition/"$directory_name"/face_recognition
cp "$directory_name"/face_recognition/parsed_face.txt ../keep_recognition/"$directory_name"/face_recognition
cp "$directory_name"/face_recognition/face.txt ../keep_recognition/"$directory_name"/face_recognition

cd "$directory_name"/face_recognition/share
tar czvf all_recognized.tgz recognized_*txt
cd -

cp "$directory_name"/face_recognition/share/all_recognized.tgz ../keep_recognition/"$directory_name"/face_recognition

### subtitles file

cp "$directory_name".srt ../keep_recognition/"$directory_name"/

echo "Delete directory ?"

read -n 1
if [ "$REPLY" == "y" ];then
  rm -fr "$directory_name"
fi

mv "$directory_name"* ../keep_recognition/
