#!/bin/bash

for filename in /share/aligned_$1/*; do
  complete_number=$(echo "$filename" | sed 's|.*_\([0-9]*\)\..*|\1|g')
  number=$(echo "$filename" | sed 's|.*_0*\([0-9]*\)\..*|\1|g')
  filename_start=$(echo "$filename" | sed 's|^.*/\(.*_\)[0-9]*\..*|\1|g')
  echo "$filename $number"

  result=""

  if [ ! -e /share/recognized_${complete_number}.txt ];then
    ./demos/classifier.py infer /share/pattern_lemke/classifier.pkl "$filename" > /share/recognized_${complete_number}.txt 2>&1
    result=$(grep "lemke.*confidence" /share/recognized_${complete_number}.txt)
  fi

  confidence=0

  # check whether face was recognized
  if [ "$result" != "" ];then
    confidence=$(echo "$result" | sed 's|.*with \([01]\)\.\([0-9]*\) confidence.*|\1\2|g' | sed 's|^0*||g')
  fi

  echo "Confidence: $confidence"

  # check if confidence of recognition > 80%
  if [ $confidence -gt 80 ];then
    mkdir /share/temporary_$1

    # look at previous and next image

    let previousNumber=number-1
    formattedPreviousNumber=$(printf "%04d" $previousNumber)

    let nextNumber=number+1
    formattedNextNumber=$(printf "%04d" $nextNumber)

    # echo "/share/remaining/${filename_start}${formattedPreviousNumber}.png /share/remaining/${filename_start}${formattedNextNumber}.png"

    if [ -e "/share/remaining/${filename_start}${formattedPreviousNumber}.png" ] && [ ! -e "/share/recognized_${formattedPreviousNumber}.txt" ];then
      cp "/share/remaining/${filename_start}${formattedPreviousNumber}.png" /share/temporary_$1/
    fi

    if [ -e "/share/remaining/${filename_start}${formattedNextNumber}.png" ] && [ ! -e "/share/recognized_${formattedNextNumber}.txt" ];then
      cp "/share/remaining/${filename_start}${formattedNextNumber}.png" /share/temporary_$1/
    fi

    # temporary directory contains images
    if [ "$(ls -A /share/temporary_$1/)" ]; then

      # align the faces for previous and next image
      ./util/align-dlib.py /share/temporary_$1/ align outerEyesAndNose /share/aligned_$1 --size 96

      # identify previous and next image
      if [ -e /share/aligned_$1/"${filename_start}${formattedNextNumber}.png" ]; then
        ./demos/classifier.py infer /share/pattern_lemke/classifier.pkl /share/aligned_$1/"${filename_start}${formattedNextNumber}.png" > /share/recognized_${formattedNextNumber}.txt 2>&1
      fi

      if [ -e /share/aligned_$1/"${filename_start}${formattedPreviousNumber}.png" ]; then
        ./demos/classifier.py infer /share/pattern_lemke/classifier.pkl /share/aligned_$1/"${filename_start}${formattedPreviousNumber}.png" > /share/recognized_${formattedPreviousNumber}.txt 2>&1
      fi
    fi

    rm -fr /share/temporary_$1/
  fi

done

echo "finito" > /share/finito_$1.txt
echo "finito"
